/*
-------------------------------------------------------------------
SUDOKU SENSEI 2.00: a Sudoku Explainer Application
Copyright (C) 2007  Victor Antolin Urtueta

This program is based on SUDOKU SENSEI 1.04, a Sudoku Explainer
Engine by Martin Knoblauch.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
MA  02110-1301, USA.

Contact the authors: mentur.SudokuSensei AT gmail.com
                     comocomocomo AT users.sourceforge.net
Latest versions: http://sourceforge.net/projects/sudoku-sensei
-------------------------------------------------------------------
*/
/************************************************************************************************/
/*  File: Dshowabout.h  * Status: stable * Version: 2.00 * last changes in version: 0.36 	*/
/************************************************************************************************/
/*  This file contains the definitions of ShowAboutDialog class 				*/
/*												*/
/*   The functions class' are defined in Dshowabout.cpp						*/
/*												*/
/*   It's called by MyMainWindow class defined in mainwindow.h, mainwindow.cpp, Dmainwindow.ui  */
/*												*/
/*   It's based in ShowSolutionDialog class defined in Dshowsolution.h, Dshowsolution.cpp 	*/
/*												*/
/************************************************************************************************/

#ifndef DSHOWABOUT_H
#define DSHOWABOUT_H
#define DIF_MIN 1
#define DIF_MAX 100
#define DIF_DEFAULT 50
#include <QDialog>
#include <QTextBrowser>
#include <QHBoxLayout>
#include <QVBoxLayout>


// Include that to compile faster

class QTextBrowser;
class QPushButton;
class QHBoxLayout;
class QVBoxLayout;

 

//Clase ShowAboutDialog
class ShowAboutDialog : public QDialog
{
	Q_OBJECT

private:

	/* Variables */
	bool English1OrSpanish0;	// Language Variable
					// English = true ; Spanish = false 

	/* GUI Objects */
 	QTextBrowser *TextBrowser;	
	QPushButton *botClose;
	QHBoxLayout * LayoutButtons;
	QVBoxLayout * MainLayout;

public:

	ShowAboutDialog(bool English = 1,QWidget *parent = 0); 	// Constructor
	~ShowAboutDialog();					// Destructor
};
#endif

