/*
-------------------------------------------------------------------
SUDOKU SENSEI 2.00: a Sudoku Explainer Application
Copyright (C) 2007  Victor Antolin Urtueta

This program is based on SUDOKU SENSEI 1.04, a Sudoku Explainer
Engine by Martin Knoblauch.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
MA  02110-1301, USA.

Contact the authors: mentur.SudokuSensei AT gmail.com
                     comocomocomo AT users.sourceforge.net
Latest versions: http://sourceforge.net/projects/sudoku-sensei
-------------------------------------------------------------------
*/
/************************************************************************************************/
/*  File: SudokuWidget.h    * Status: stable * Version: 1.00 * last changes in version: 0.10 	*/
/************************************************************************************************/
/*  This file contains definition of SudokuWidget class                                  	*/
/*												*/
/*   The class functions are defined in SudokuWidget.cpp                              		*/
/*												*/
/*   It's called by MyNewBoard class defined in newtable.h, newtable.cpp, Dnewtable.ui	        */
/*												*/
/*   It's based in SudokuView class defined in SudokuView.h, SudokuView.cpp			*/
/************************************************************************************************/
#ifndef SUDOKUWIDGET_H
#define SUDOKUWIDGET_H
#include <QColor>
#include <QImage>
#include <QWidget>
#include "sudoku-pub.h"


/********************************************************************************/
/* Class SudokuWidget                                                           */
/********************************************************************************/
/* This class is a Widget which can create and show preview of sudokus.         */
/*                                                                              */
/********************************************************************************/
class SudokuWidget : public QWidget
{
    Q_OBJECT

public:
    // TODO: delete this
    // QWidget *padre; 


    SudokuWidget( QWidget *parent = 0);                    // Constructor
 //   SudokuWidget(t_board_p board , QWidget *parent = 0);   // Constructor with a given board
    t_board_p sudoku_board;				   // board pointer.


    t_board_p CreateSimpleSudoku(int order = 3, char diag = 0); // Create a Simple Sudoku 
								// ( 1 Grid, block = 3 x 3 )
    t_board_p CreateSamurai(
                             char wb = 3,     /* Block width */
                             char hb = 3,     /* Block height */
                             char diag = 0);   /* TRUE == diagonals */

    t_board_p CreateCustom ( int nGrids,  /* Num. composed grids */
                             int * xg,    /* Coordinates of */
                             int * yg,
			     char wb = 3,     /* Block width */
                             char hb = 3,     /* Block height */
                             char diag = 0   /* TRUE == diagonals */
                             );
   ~SudokuWidget() { DestroyBoard (sudoku_board);} // Destructor

    void paintEvent(QPaintEvent *event);  // Paints the preview
/*TODO: delete this
private:
    void setImagePixel(const QPoint &pos, bool opaque);
    QRect pixelRect(int i, int j) const;*/

	// TODO: ¿ Are they used ?
    QColor curColor;
    QImage image;
    int zoom;
};
#endif
