/*
-------------------------------------------------------------------
SUDOKU SENSEI 2.00: a Sudoku Explainer Application
Copyright (C) 2007  Victor Antolin Urtueta

This program is based on SUDOKU SENSEI 1.04, a Sudoku Explainer
Engine by Martin Knoblauch.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
MA  02110-1301, USA.

Contact the authors: mentur.SudokuSensei AT gmail.com
                     comocomocomo AT users.sourceforge.net
Latest versions: http://sourceforge.net/projects/sudoku-sensei
-------------------------------------------------------------------
*/
/************************************************************************************************/
/*  File: dmem.cpp  * Status: stable * Version: 2.00 * last changes in version: 0.36 		*/
/************************************************************************************************/
/*  This file contains functions to check memory leaks  					*/
/*												*/
/*   See dmem.h											*/
/*												*/
/*   It's called by all files.									*/
/*												*/
/************************************************************************************************/

#include <map>
#include <iostream>
#include "dmem.h"

std::map<void *, mem_reg> bloques;



/*****************/
/* dump_blocks   */
/********************************************************/
/* This fuction check if there are memory leaks.        */
/* It must be the last called fuction                   */
/********************************************************/
/* Used only in debug					*/
/********************************************************/
void dump_blocks ()
{
  typedef std::map<void *, mem_reg>::iterator iterator;

  if (bloques.empty())
  {
    cerr.flush ();
    cout << endl << "Correcto. Todo liberado OK." << endl;
    cout.flush ();
  }
  else
  {
    cout.flush ();
    cerr << endl << "MEMORIA SIN LIBERAR:" << endl;
    for (iterator it=bloques.begin(); it!=bloques.end(); ++it)
      cerr << "Bloque sin liberar "
           << "(new en " << it->second.file << ":"
           << it->second.function << ":"
           << it->second.line << ")" << endl;
    cerr.flush ();
  }
}

