/*
-------------------------------------------------------------------
SUDOKU SENSEI 2.00: a Sudoku Explainer Application
Copyright (C) 2007  Victor Antolin Urtueta

This program is based on SUDOKU SENSEI 1.04, a Sudoku Explainer
Engine by Martin Knoblauch.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
MA  02110-1301, USA.

Contact the authors: mentur.SudokuSensei AT gmail.com
                     comocomocomo AT users.sourceforge.net
Latest versions: http://sourceforge.net/projects/sudoku-sensei
-------------------------------------------------------------------
*/
/************************************************************************************************/
/*  File: graphics.h    * Status: unstable * Version: 1.0 * finished in version: 0.35 		*/
/************************************************************************************************/
/*        									      		*/
/*  This file contains modifications that must be included to 					*/
/*   a faster compilation of GraphCell class in sudoku-pr.h					*/
/*        									      		*/
/************************************************************************************************/

#ifndef GRAPHICS_H
#define GRAPHICS_H

#include <QtWidgets>
#include "sudoku-pub.h"

// Include that to compile faster
class QGraphicsItem;
class QGraphicsRectItem;
class QGraphicsScene;

class SudokuBoard;

/* Extern variables to GraphCell */
//bool mShiftActive=false;

class GraphCell : public QGraphicsRectItem
{
	//Q_OBJECT

	public:

      SudokuBoard * board;

// 	GraphCell * pCellsIcanInfluence; /* Array of Cells that this cell can influence when it has a final value */
//  	short    nCellsIcanInfluence; /* Number of Cells that this cell can influence when it has a final value */

//  	GraphCell * pCellsCanInfluenceMe; /* Array of Cells that can influence in this cell */
//  	short    nCellsCanInfluenceMe; /* Number of Cells that can influence in this cell */

//  	GraphCell * pCellsInfluenceZone;  /* PCellsIcanInfluence + pCellsCanInfluenceMe */
//  	short    nCellsInfluenceZone;  /* nCellsIcanInfluence + nCellsCanInfluenceMe */

	QGraphicsSimpleTextItem   ** pTextPoss;   /* Array with Strings of Text Symbols that can be Select */
	short 		 nTextPoss;   /* Number of pTextPoss array of Strings */
	int		 mTextPoss;  /* Mask of Text Symbols that can be Select */ 

	QGraphicsSimpleTextItem  TextFinalValue; /* Big text item of can be valued */
	bool   canChange;
	bool   FvActivate;
	

//	void * mEnlarge;

	void focusInEvent ( QFocusEvent * event );
	void focusOutEvent ( QFocusEvent * event );
	void mousePressEvent (QGraphicsSceneMouseEvent * event);
	void mouseDoubleClickEvent ( QGraphicsSceneMouseEvent * event );
	void keyPressEvent (QKeyEvent * event);
	void paint ( QPainter * painter, const QStyleOptionGraphicsItem * option, QWidget * widget = 0);

	void setFinalUserValue(int value);
	void setPossUserValue(int value);
	void UpdatePossUserText( int littlesize, int n_lines, int maskToHide = 0, bool clearRule= false);
	void ClearCell();
	void UpdateCell();
	//void setEnlargeWindow( void * Enlarge );

// TODO: More funcionality

	GraphCell (  QGraphicsItem * parent=0 );
//	GraphCell (  const QRectF & rect, QGraphicsItem * parent=0, QGraphicsScene * scene = 0);
//	GraphCell ( qreal x, qreal y, qreal width, qreal height, QGraphicsItem * parent=0, QGraphicsScene * scene = 0);

	~GraphCell();
};


#endif
