/*
-------------------------------------------------------------------
SUDOKU SENSEI 2.00: a Sudoku Explainer Application
Copyright (C) 2007  Victor Antolin Urtueta

This program is based on SUDOKU SENSEI 1.04, a Sudoku Explainer
Engine by Martin Knoblauch.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
MA  02110-1301, USA.

Contact the authors: mentur.SudokuSensei AT gmail.com
                     comocomocomo AT users.sourceforge.net
Latest versions: http://sourceforge.net/projects/sudoku-sensei
-------------------------------------------------------------------
*/
/************************************************************************************************/
/*  File: mask.h  * Status: stable * Version: 2.00 * last changes in version: 0.50		*/
/************************************************************************************************/
/*  This file contains the headers of the functions: mask, simbols and SimbolsOfMask		*/
/*												*/
/************************************************************************************************/
#ifndef _MASK_H_
#define _MASK_H_

#include <Qt>
#include <QString>

class QString;

#define SYMBOLS_STRING "12345" \
                       "6789A" \
                       "BCDEF" \
                       "GJKLM" \
                       "NPRTU" \
                       "VWYS0"

#define SYMBOLS_KEYS                                      \
{                                                         \
  Qt::Key_1, Qt::Key_2, Qt::Key_3, Qt::Key_4, Qt::Key_5,  \
  Qt::Key_6, Qt::Key_7, Qt::Key_8, Qt::Key_9, Qt::Key_A,  \
  Qt::Key_B, Qt::Key_C, Qt::Key_D, Qt::Key_E, Qt::Key_F,  \
  Qt::Key_G, Qt::Key_J, Qt::Key_K, Qt::Key_L, Qt::Key_M,  \
  Qt::Key_N, Qt::Key_P, Qt::Key_R, Qt::Key_T, Qt::Key_U,  \
  Qt::Key_V, Qt::Key_W, Qt::Key_Y, Qt::Key_S, Qt::Key_0   \
}

inline int mask (int value)
{
  return ( int (1) << value) ;  
}

inline int mask_all (int num_symbols)
{
  return ~ (~0UL << num_symbols);  
}

inline const char * symbols_string (void)
{
  return SYMBOLS_STRING;
}

inline char simbols (char num) 
{
  return num>=0 && num<30 ? SYMBOLS_STRING[(unsigned)num] : '0';
/*
	  if ( num <= 8) return '1' + num;
	  if ( num <= 14) return 'A' + num - 9;
	  if ( num == 15) return 'G';
	  if ( num <= 20) return 'J' + num -16;
	  if ( num == 21) return 'P';
	  if ( num == 22) return 'R';
	  if ( num <= 26) return 'T' + num -23;
	  if ( num == 27) return 'Y';
	  if ( num == 28) return 'S';
	  else return '0';
*/
}

QString SimbolsOfMask (int the_mask,int nSy, QString space);
#endif 
