/*
-------------------------------------------------------------------
SUDOKU SENSEI 2.00: a Sudoku Explainer Application
Copyright (C) 2007  Victor Antolin Urtueta

This program is based on SUDOKU SENSEI 1.04, a Sudoku Explainer
Engine by Martin Knoblauch.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
MA  02110-1301, USA.

Contact the authors: mentur.SudokuSensei AT gmail.com
                     comocomocomo AT users.sourceforge.net
Latest versions: http://sourceforge.net/projects/sudoku-sensei
-------------------------------------------------------------------
*/
/************************************************************************************************/
/*  File: newgame.h    * Status: stable * Version: 2.0 * finished in version: 0.26 		*/
/************************************************************************************************/
/*  This file contains definition of NewGame class                                  		*/
/*        									      		*/
/*   The class functions are defined in newgame.cpp                                  		*/
/*												*/
/*   It's called by MyMainWindow class defined in mainwindow.h, mainwindow.cpp, Dmainwindow.ui	*/
/*												*/
/************************************************************************************************/

#ifndef NEWGAME_H
#define NEWGAME_H
#define DIF_MIN 1
#define DIF_MAX 100
#define DIF_DEFAULT 50
#include <QDialog>
#include <QTextEdit>
#include <QHBoxLayout>
#include <QVBoxLayout>


// Include that to compile faster
class QRadioButton;
class QLabel;
class QTextEdit;
class QPushButton;
class QSlider;
class QButtonGroup;
class QCheckBox;
class QHBoxLayout;
class QVBoxLayout;

 

//Clase NewGame
class NewGame : public QDialog
{
	Q_OBJECT
	Q_PROPERTY(char moutput READ output WRITE setOutput)


private:

	/* GUI */
	char moutput;
	QLabel *min;
	QLabel *medium;
	QLabel *max;
	QLabel *leveldif1;
	QLabel *leveldif2;
	QRadioButton *BoardEmpty;
	QRadioButton *BoardGenerate;
	QRadioButton *BoardWrited;
	QButtonGroup *RadioGroup;
	QSlider *level;
	QCheckBox *highdif;
	QTextEdit *TextBoard;
	QPushButton *botAcept;
	QPushButton *botClose;

	QHBoxLayout * LayoutTextSlider;
	QVBoxLayout * LayoutSliderPlus;
	QVBoxLayout * LayoutLevelDif;
	QHBoxLayout * LayoutDIF;
	QHBoxLayout * LayoutButtons;
	QVBoxLayout * MainLayout;

public:

	NewGame(QWidget *parent = 0);
	~NewGame();
	char output(){ return moutput; }
	void setOutput( char a){ moutput = a; }
	QString rawTable(){ return TextBoard->toPlainText();} 
/*
signals:
	void GenerateProblem( int difficulty);
	void GenerateBoard( QString &stringBoard);
	void Cancel(); *//* TODO: NO USED */
private slots:
	void aceptClicked();
	void changeEasy();
//	void enableAcept(const int opcion, const int difficulty,
//			   const QString &stringBoard);

	
};
#endif
