/*
-------------------------------------------------------------------
SUDOKU SENSEI 2.00: a Sudoku Explainer Application
Copyright (C) 2007  Victor Antolin Urtueta

This program is based on SUDOKU SENSEI 1.04, a Sudoku Explainer
Engine by Martin Knoblauch.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
MA  02110-1301, USA.

Contact the authors: mentur.SudokuSensei AT gmail.com
                     comocomocomo AT users.sourceforge.net
Latest versions: http://sourceforge.net/projects/sudoku-sensei
-------------------------------------------------------------------
*/
/************************************************************************************************/
/*  File: progress.cpp  * Status: stable * Version: 2.00 * last changes in version: 0.45  	*/
/************************************************************************************************/
/*  This file contains functions of MyProgress class	   					*/
/*												*/
/*   The class is defined in progress.h								*/
/*   This dialog is defined in Dprogress.ui                                       		*/
/*												*/
/*   It's called by MainWindow class defined in mainwindow.h, mainwindow.cpp and Dmainwindow.ui	*/
/*												*/
/*   It calls the CreatorThread class defined in thread-creator.h			 	*/
/*												*/
/************************************************************************************************/

#include "progress.h"
/***************/
/* Constructor */
/***************/
MyProgress::MyProgress(QWidget * p, CreatorThread * pThread) : QDialog(p), pCreatorThread(pThread)
{
	if ( !pCreatorThread) return;
	setupUi(this);

	connect(CancelButton,SIGNAL(pressed()),this,SLOT (mCancel()) );

	connect(pCreatorThread, SIGNAL(finished()),this,SLOT (mAccept()) );

	connect(pCreatorThread, SIGNAL(advanceSignal( int )),this, SLOT (mAdvance(int )) );
	
	user_say=true;

	pCreatorThread->Start_running ();
}
/***********/
/* mCancel */
/***********/
void MyProgress::mCancel()
{
	pCreatorThread->setFlagCancel(true);
	user_say=false;
	pCreatorThread->Wait_for_completion ();
	reject();
}
/***********/
/* mAccept */
/***********/
void MyProgress::mAccept()
{
	accept();
}

/************/
/* mAdvance */
/************/
void MyProgress::mAdvance(int number)
{
	progressBar->setValue(number);
}
