/*
-------------------------------------------------------------------
SUDOKU SENSEI 2.00: a Sudoku Explainer Application
Copyright (C) 2007  Victor Antolin Urtueta

This program is based on SUDOKU SENSEI 1.04, a Sudoku Explainer
Engine by Martin Knoblauch.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
MA  02110-1301, USA.

Contact the authors: mentur.SudokuSensei AT gmail.com
                     comocomocomo AT users.sourceforge.net
Latest versions: http://sourceforge.net/projects/sudoku-sensei
-------------------------------------------------------------------
*/
/************************************************************************************************/
/*  File: progress.h  * Status: stable * Version: 2.00 * last changes in version: 0.45  	*/
/************************************************************************************************/
/*  This file contains headers of MyProgress class	   					*/
/*												*/
/*   The class functions are defined in progress.cpp						*/
/*   This dialog is defined in Dprogress.ui                                       		*/
/*												*/
/*   It's called by MainWindow class defined in mainwindow.h, mainwindow.cpp and Dmainwindow.ui	*/
/*												*/
/*   It calls the CreatorThread class defined in thread-creator.h			 	*/
/*												*/
/************************************************************************************************/

#ifndef PROGRESS_H
#define PROGRESS_H
#include <QDialog>
#include "ui_Dprogress.h"
#include "thread-creator.h"

class MyProgress : public QDialog, Ui_Progress
{
    Q_OBJECT

private:
	CreatorThread * pCreatorThread;
public:
	MyProgress(QWidget * p, CreatorThread * pThread = NULL);   /* Constructor */
	bool user_say;
signals:


public slots:
	void mCancel();
	void mAccept();
	void mAdvance(int number);
};

#endif
