/*
-------------------------------------------------------------------
SUDOKU SENSEI 2.00: a Sudoku Explainer Application
Copyright (C) 2007  Victor Antolin Urtueta

This program is based on SUDOKU SENSEI 1.04, a Sudoku Explainer
Engine by Martin Knoblauch.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
MA  02110-1301, USA.

Contact the authors: mentur.SudokuSensei AT gmail.com
                     comocomocomo AT users.sourceforge.net
Latest versions: http://sourceforge.net/projects/sudoku-sensei
-------------------------------------------------------------------
*/
/************************************************************************************************/
/*  File: sudoku-creator.h  * Status: stable * Version: 2.00 * last changes in version: 0.50	*/
/************************************************************************************************/
/*  This file contains the headers of functions which are used by CreatorThread			*/
/*												*/
/*  This functions are based in sudokusensei v1.0 functions					*/
/*												*/
/************************************************************************************************/

#ifndef  SUDOKU_CREATOR_H
#define  SUDOKU_CREATOR_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include <QtCore>
#include <QStringList>

#include "sudoku-pub.h"
class CreatorThread;

#ifdef WINDOWS
#define SYSTEM_PAUSE system ("pause")
#else
#define SYSTEM_PAUSE
#endif

/*////////////////////////////////////////////////////////////// */

#define MAX_GRIDS 100
#define MAX_DIST 1000
#define MAX_NUM 10000
#define MAX_TRIALS 10

typedef struct s_params
{
  int blockWidth, blockHeight;
  int nGrids;
  int * offsetsX, * offsetsY;
  char samurai, diagonals;
  int num;
  int restrictinters;
  char * name; // Add By Victor Antolin
  float level; // Add By Victor Antolin
}
t_params;

int sudokuCreator (QStringList arguments, CreatorThread * pThread);

int CreateProblems (t_board_p b, t_params * p,
                    int * cells, int * symbols, int * masks,
                    char * given,
                    int serial,
                    CreatorThread * pThread = NULL,
                    bool highdificult = false);

void ShuffleBoard (t_board_p b, t_params * p,
                   int * A, int * B, int * index);

int FillBoard (t_board_p b,
               int * cells, int * symbols, int * masks,
               CreatorThread * pThread = NULL);

int LoadBoard (t_board_p b, t_params * p);
void SaveBoard (t_board_p b, t_params * p);

int ParseParams (t_params * p, QStringList arg);
void FreeParams (t_params * p);

int my_random (int num);
void random_index (int num, int * index);

/*////////////////////////////////////////////////////////////// */

#endif
