/*
-------------------------------------------------------------------
SUDOKU SENSEI 2.00: a Sudoku Explainer Application
Copyright (C) 2007  Victor Antolin Urtueta

This program is based on SUDOKU SENSEI 1.04, a Sudoku Explainer
Engine by Martin Knoblauch.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
MA  02110-1301, USA.

Contact the authors: mentur.SudokuSensei AT gmail.com
                     comocomocomo AT users.sourceforge.net
Latest versions: http://sourceforge.net/projects/sudoku-sensei
-------------------------------------------------------------------
*/
/************************************************************************************************/
/*  File: treesdkview.h    * Status: unstable * Version: 1.0 * finished in version: 0.29 	*/
/************************************************************************************************/
/*        									      		*/
/*  This file contains definition and functions of TreeSdkView class                   		*/
/*        									      		*/
/*   It's called by MyNewBoard class defined in newtable.h, newtable.cpp and ui_Dnewtable.h     */
/************************************************************************************************/
#ifndef TREESDKVIEW_H
#define TREESDKVIEW_H
#include <QTreeView>

/********************************************************************************/
/* Class TreeSdkView                                                            */
/********************************************************************************/
/* This class add signal selectChanged. This signal is emited when the user     */
/* do any movement with the keyboard.                                           */
/* In this case, we use this signal to activate a preview of the board          */
/********************************************************************************/
class TreeSdkView : public QTreeView
{
    Q_OBJECT

	public:

	TreeSdkView( QWidget * parent = 0): QTreeView(parent) {}
	signals:
		void selectChanged(const QModelIndex & index );
	protected:

	void keyPressEvent ( QKeyEvent * event ) { QTreeView::keyPressEvent (event);
						   emit selectChanged( currentIndex() ) ;}
};

#endif
